#version 330 compatibility

layout (location = 0) in vec3 position;

uniform mat4 proj;
uniform mat4 model;
uniform int width;
uniform int height;
uniform int depth;

out vec4 fragMainColor;

void main(void)
{
    vec4 cam = vec4(0, 0, (width + height + depth) / sin(radians(60.0) * 2), 0.0);
    vec3 offset = vec3(-0.025, -0.025, -0.0175);
    gl_Position = proj * (model * vec4(position + offset, 1.0) - cam);
}